//+------------------------------------------------------------------+
//|                                                   II_Buzzard.mq4 |
//|                            Copyright  2009, Insanity Industries |
//|                                http://www.insanityindustries.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Insanity Industries"
#property link      "http://www.insanityindustries.net"
#property indicator_chart_window

extern color color_long.message = Green;
extern color color_short.message = Red;
extern string II_Font = "Arial Bold";
extern int II_Size = 8;
extern int corner = 1;
extern int pos.x = 100;
extern int pos.y = 370;

extern color cell_color = MintCream;
extern color border_color = SteelBlue;
extern bool Drop.Shadows = true;
extern int Shadow.Depth = 2;
extern color shadow_color = DarkGray;


string TAG = "II_Buzzard";
double point;
string msg;
color color_msg = DimGray;
string pair,ShortName;
int tf;
int candle[4];
bool draw.box;
string BuzChar = "V";
string BuzFont = "Birds Of A Feather";

int init()
{
   tf = Period();
   pair = Symbol();
   point = Point;
   if(Digits == 3 || Digits == 5) point*=10;
   ShortName    =  TAG+pair+Period() ;

   return(0);
}

int deinit()
{
   ObDeleteObjectsByPrefix(ShortName);
   return(0);
}

int start()
{
   int i;
   double o,c;
   for(i=0;i<4;i++)
   {
      candle[i] = 0;
      o = iOpen(pair,tf,i);
      c = iClose(pair,tf,i);
      if(o<c) candle[i] = 1;
      if(o>c) candle[i] = -1;
   }
   
   msg = "NO BUZZARD";
   draw.box = false;
   
   if(candle[3] == 1 && candle[1] == 1 && candle[2] == 1)
   {
      msg = "GO SHORT ON RED CANDLE";
      color_msg = color_short.message;
      draw.box = true;
   }
   if(candle[3] == -1 && candle[1] == -1 && candle[2] == -1)
   {
      msg = "GO LONG ON GREEN CANDLE";
      color_msg = color_long.message;
      draw.box = true;
   }
   if(candle[0] == 1 && candle[1] == 1 && candle[2] == 1 && candle[3] != 1)
   {
      msg = "THE BUZZARDS ARE CIRCLING";
      color_msg = color_short.message;
      draw.box = true;
   }      
   if(candle[0] == -1 && candle[1] == -1 && candle[2] == -1 && candle[3] != -1)
   {
      msg = "THE BUZZARDS ARE CIRCLING";
      color_msg = color_long.message;
      draw.box = true;
   }

   if(draw.box)draw.Box();
      else ObDeleteObjectsByPrefix(TAG);

   return(0);
}

void draw.Box()
{
   if (Drop.Shadows && ObjectFind(TAG+".gauge.A1") != 0)
   {
      int x,y;
      if(corner == 0 || corner == 2) {x= pos.x-30+Shadow.Depth; y=pos.y-20+Shadow.Depth;}
      if(corner == 1 || corner == 3) {x= pos.x-30-Shadow.Depth; y=pos.y-20+Shadow.Depth;}
      
      DrawCell(0, TAG+".gauge.A1", x, y, 140, 124, shadow_color,corner);
   }
   if (ObjectFind(TAG+".gauge.border1") != 0) DrawCell(0, TAG+".gauge.border1", pos.x-30, pos.y-20, 140, 124, border_color,corner);
   if (ObjectFind(TAG+".gauge.box1") != 0)    DrawCell(0, TAG+".gauge.box1",    pos.x-28, pos.y-19, 138, 122, cell_color,corner);

   string label = TAG+"MSG";  
   ObjectCreate(label, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(label, msg , II_Size ,  II_Font,  color_msg );
   ObjectSet(label, OBJPROP_CORNER, corner);
   ObjectSet(label, OBJPROP_XDISTANCE, pos.x+3 );
   ObjectSet(label, OBJPROP_YDISTANCE, pos.y+140 );
   label = TAG+"BUZ";  
   ObjectCreate(label, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(label, BuzChar , 40 ,  BuzFont,  color_msg );
   ObjectSet(label, OBJPROP_CORNER, corner);
   ObjectSet(label, OBJPROP_XDISTANCE, pos.x+10 );
   ObjectSet(label, OBJPROP_YDISTANCE, pos.y );
   label = TAG+"ABUZ";
   ObjectCreate(label, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(label, BuzChar , 40 ,  BuzFont,  Black );
   ObjectSet(label, OBJPROP_CORNER, corner);
   ObjectSet(label, OBJPROP_XDISTANCE, pos.x+8 );
   ObjectSet(label, OBJPROP_YDISTANCE, pos.y+2 );   
   
}

void DrawCell(int nWindow, string nCellName, double nX, double nY, double nWidth, double nHeight, color nColor, int cnr)
{
   double   iHeight, iWidth, iXSpace;
   int      iSquares, i;
   
   if(nWidth > nHeight)
   {
     iSquares = MathCeil(nWidth/nHeight);      // Number of squares used.
     iHeight  = MathRound((nHeight*100)/77);   // Real height size.
     iWidth   = MathRound((nWidth*100)/77);    // Real width size.
     iXSpace  = iWidth/iSquares - ((iHeight/(9-(nHeight/100)))*2);
     
      for(i=0;i<iSquares;i++)
      {
         ObjectCreate   (nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText  (nCellName+i, CharToStr(110),iHeight, "Wingdings", nColor);
         ObjectSet      (nCellName+i, OBJPROP_XDISTANCE,nX + iXSpace*i);
         ObjectSet      (nCellName+i, OBJPROP_YDISTANCE,nY);    
//         ObjectSet      (nCellName+i, OBJPROP_BACK, true);
         ObjectSet      (nCellName+i, OBJPROP_BACK, false);
         ObjectSet      (nCellName+i, OBJPROP_CORNER, cnr);
      }        
   }else{
      iSquares = MathCeil(nHeight/nWidth);      // Number of squares used.
      iHeight  = MathRound((nHeight*100)/77);   // Real height size.
      iWidth   = MathRound((nWidth*100)/77);    // Real width size.
      iXSpace  = iHeight/iSquares - ((iWidth/(9-(nWidth/100)))*2);   
 
      for(i=0;i<iSquares;i++)
      {
         ObjectCreate   (nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText  (nCellName+i, CharToStr(110),iWidth, "Wingdings", nColor);
         ObjectSet      (nCellName+i, OBJPROP_XDISTANCE,nX);
         ObjectSet      (nCellName+i, OBJPROP_YDISTANCE,nY + iXSpace*i);    
//         ObjectSet      (nCellName+i, OBJPROP_BACK, true);
         ObjectSet      (nCellName+i, OBJPROP_BACK, false);
         ObjectSet      (nCellName+i, OBJPROP_CORNER, cnr);
      }       
   }
}

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }

